︠e9a6a3ad-6e05-4840-822f-6e30fcefddc1︠
Author: Vincent J. Matsko
Date: 3 January 2016, Day020
Post: Envelopes I
︡1a0f8710-d87f-4134-b787-bcc759f8d1ff︡
︠c391fb68-6f0e-4f1a-a9a3-f451affc0b49︠
from sage.plot.colors import rgbcolor
# Don't forget to copy to a project of your own!

# We have to be careful with points in Python.
# To easily perform mathematical operations, we need to work with vectors, which are mathematical objects.
# Then we need to use the vectors to make lines, which are graphics objects.
# The color argument is a list of RGB values.
def envelope (P, R, Q, n, color): # n is the number of lines in the envelope.
    # Converting to vectors.
    vP = vector(P);
    vR = vector(R);
    vQ = vector(Q);
    # The envelope lines will be stored here.
    envlines = [];
    for i in range(n):  # remember that in Python, i will begin at 0.
        # Use linear interpolation here, and set the color.
        envlines.append(line([(n-i)/n * vP + i/n * vR, (n-i-1)/n * vR + (i+1)/n * vQ], rgbcolor=color));
    # Returns the lines for use in other functions.
    return sum(envlines);
︡565cb0ed-38e5-4bbe-898c-96f27056f1f1︡︡{"done":true}
︠61e3394e-c84f-4ac5-811e-194015533ec2︠
# Python uses the "+" to concatenate graphics elements.
# Use an aspect ratio of 1 so that the scales on the x and y axes are the same.
# Set the axes keyword to False so the axes don't show up.
show(envelope ([0,1],[0,0],[1,0],15,(1,0.5,0)) + envelope ([0,1],[0,0],[-1,0],15,(0.5,0,1)) + envelope([0,-1],[0,0],[-1,0],15,(1,0.5,0)) + envelope([0,-1],[0,0],[1,0],15,(0.5,0,1)),aspect_ratio=1,axes=False)
︡b485ed70-e408-4387-937c-c0acc8e40ee3︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"c7c5b29b-d6b8-4911-86c2-065ff817b6b8","filename":"/projects/48a4f88a-5167-45ae-a54c-f4c735940fa0/.sage/temp/compute3-us/28427/tmp_srDU1U.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠14478670-9a4f-4597-90f2-259239fb2f0a︠











